{Delphi 97 screensaver for NT 4.0/Windows95  Sven George
Based on Meik Weber's "Fade in, Fade out" screensaver for Windows95

You have the right to use the Delphi 97 screensaver code for any non-commercial
use if you include end user seen text that gives some credit to Sven George and
Meik Weber. You do not have the right to publish this source or parts of in a
magazine or in a book (online or printed). If you want to do so, you need the
written permission of Sven George and Meik Weber.

You can contact us by standard mail:
  Sven George                  Meik Weber
  Ronnvagen 11                 Ostwaldstr. 8
  S-375 31, Morrum             53115 Bonn
  Sweden                       Germany

or by E-mail:
  SveGeo@rsv.se                m.weber@public.ndh.com

This source code is provided to you AS IS without warranty of any kind,
either expressed or implied. Sven George does not warrant that the functions
contained in this source code meet your requirements or work uninterrupted
or error free. In no event will Sven George be liable to you or any third party
for any damages, including any loss of profit, lost savings or other incidental,
consequential or special damage.}

program Delphi97;
uses Forms,Windows,WinTypes,WinProcs,SysUtils,
     savInit in 'savInit.pas',
     Conf in 'Conf.pas',
     Main in 'Main.pas';

//How do I activate the screensaver from Delphi 2.0?
//DefWindowProc(Form1.Handle,WM_SYSCOMMAND,SC_SCREENSAVE,0);}
{$R *.RES}
var Mutex:THandle;

Procedure CheckPrevInst;
var PrevWnd:HWnd;
begin //Only one instance of the screensaver should be running
     Mutex:=CreateMutex(NIL,False,'SingleInstanceDelphi97scrMutex');
     If WaitForSingleObject(Mutex,10000)=Wait_Timeout then
        Application.Terminate;
     PrevWnd:=FindWindow('TD97','D97');
     If PrevWnd<>0 then
        PrevWnd:=GetWindow(PrevWnd,GW_OWNER);
     If PrevWnd<>0 then
     begin
          //If IsIconic(PrevWnd) then
             //ShowWindow(PrevWnd,SW_SHOWNORMAL)
          //else
              SetForeGroundWindow(PrevWnd);
          Application.Terminate;
     end;
end;

begin
  ShowWindow(Application.Handle,SW_HIDE); //Remove D97 icon from taskbar
  if SaverMode=savModeExecute then
  begin //do fullscreen mode
    try
       CheckPrevInst; //Check for previous instance of screensaver
       Application.Initialize;
       Application.CreateForm(TD97,D97);
    finally
       D97.HandleNeeded;
       ReleaseMutex(Mutex);
       CloseHandle(Mutex);
    end;
    Application.Run;
    //and after doing fullscreen mode, reactivate a previously active window
    if (SaverMode=savModeExecute) and (ConfigParent<>0) then
       SetForegroundWindow(ConfigParent);
  end
  else
  if (SaverMode=savModeConfigure) or (SaverMode=savModeConfigureStd) then
  begin //do config dialog
    Application.Initialize;
    Application.HelpFile:='Delphi97.hlp';
    Application.CreateForm(TD97Conf,D97Conf);
    Application.Run;
  end
  else
  if (SaverMode=savModePreview) and (ParamHandle<>0) then
     ExecPreview //run in preview mode
  else
  if (SaverMode=savModeSetPwd) and (ParamHandle<>0) then
     ExecSetPwd; //show the change password dialog
  ShowWindow(Application.Handle,SW_RESTORE); //Enable D97 icon for correct shutdown
end.
